function out_reset()
{
	sym = ""
	pins=""
	delete PIN
	delete ATTR
	delete CATTR
}

function out_all(    a)
{
	# copy symbol attribues to attributes _not_ appending or overwriting
	# component (local) attributes
	for(a in CATTR)
		if (!a in ATTR)
			ATTR[a] = CATTR[a]
	summary_out()
	out_reset()
}

function sch_comp_start()
{
}

function sch_comp_end()
{
	out_all()
}

function sch_sym_attr(key, val)
{
	set_attr_str($0, 1)
}

function sch_instance_attr(key, val)
{
	set_attr_str($0)
}

function sch_pin_start()
{
	pins=pins " " inpin
}

function sch_pin_attr(key, val)
{
	PIN[inpin, key] = val
}

function sch_pin_end()
{
}

function error(msg   ,where)
{
	if ("refdes" in ATTR)
		where = "in component " ATTR["refdes"] " "

	if (sym != "")
		where = where "symbol " sym " "

	where = where "near line " NR
	print "devmap summary error: " msg  " (" where ")" > "/dev/stderr"
	fatal = 1
	exit
}


END {
	if (fatal)
		exit 1
	out_all()
}
